// C++ code
//
#include <Servo.h>
#include <stdlib.h>

Servo myservo1;
Servo myservo2;
int state = 0;
int servo1_pin = 9;
int servo2_pin = 8;
int button = 4;
int i = 1;
void setup_interaption(){
  
    cli();
    
    PCICR |= (1 << PCIE2);      // enable the pin change interrupt, set PCIE2 to enable PCMSK2 scan
    PCMSK2 |= (1 << PCINT20);   // set the interaption for pin 4(PCINT20)
    sei();
}

void setup()
{

  myservo1.attach(servo1_pin); // set the first servo that lift the lead
  myservo2.attach(servo2_pin); // set the second servo that switch the button 
  myservo1.write(0);  // position them to 0 
  myservo2.write(0);  // position them to 0
  delay(1000);        // wait for the servo to be positioned
  pinMode(button, INPUT_PULLUP);   // set the button
  setup_interaption();    // set the interaption
}

ISR(PCINT2_vect){
  if(digitalRead(button) == LOW)     // detect if the button is switched to activate the mechanism
    state = 1;
}

void function1(){
  int pos;
    for (pos = 0; pos <= 90; pos += 1) { // goes from 0 degrees to 90 degrees to lift the lead
      // in steps of 1 degree
      myservo1.write(pos);              // tell servo to go to position in variable 'pos'
      delay(10);                       // waits for the servo to reach the position
    }
    for (pos = 0; pos <= 120; pos += 1) { // goes from 0 degrees to 120 degrees to switch the button
      // in steps of 1 degree
      myservo2.write(pos);              // tell servo to go to position in variable 'pos'
      delay(5);                       // waits for the servo to reach the position
    }
   delay(2000);
    for (pos = 120; pos >= 0; pos -= 1) { // goes from 120 degrees to 0 degrees to return to normal position
      myservo2.write(pos);              // tell servo to go to position in variable 'pos'
      delay(5);                       // waits for the servo to reach the position
    }
    for (pos = 90; pos >= 0; pos -= 1) { // goes from 90 degrees to 0 degrees to return to normal position
      myservo1.write(pos);              // tell servo to go to position in variable 'pos'
      delay(10);                       // waits for the servo to reach the position
    }
    state = 0;
}

void function2(){
  int pos;
    for (pos = 0; pos <= 90; pos += 1) { // goes from 0 degrees to 90 degrees to lift the lead
      // in steps of 1 degree
      myservo1.write(pos);              // tell servo to go to position in variable 'pos'
      delay(2);                       // waits for the servo to reach the position
    }
    delay(100);
    for (pos = 0; pos <= 120; pos += 1) { // goes from 0 degrees to 120 degrees to switch the button
      // in steps of 1 degree
      myservo2.write(pos);              // tell servo to go to position in variable 'pos'
      delay(2);
    }
    delay(200);
    for (pos = 120; pos >= 0; pos -= 1) { // goes from 120 degrees to 0 degrees to return to normal position
      myservo2.write(pos);              // tell servo to go to position in variable 'pos'
      delay(2);
    }
    delay(100);
    for (pos = 90; pos >= 0; pos -= 1) { // goes from 90 degrees to 0 degrees to return to normal position
      myservo1.write(pos);              // tell servo to go to position in variable 'pos'
      delay(2);                       // waits for the servo to reach the position
    }
    state = 0;
}
void function3(){
  int pos;
    for (pos = 0; pos <= 90; pos += 1) { // goes from 0 degrees to 90 degrees to lift the lead
      // in steps of 1 degree
      myservo1.write(pos);              // tell servo to go to position in variable 'pos'
      delay(10);                       // waits for the servo to reach the position
    }
    delay(2000);
    for (pos = 0; pos <= 105; pos += 1) { // goes from 0 degrees to 120 degrees to switch the button
      // in steps of 1 degree
      myservo2.write(pos);              // tell servo to go to position in variable 'pos'
      delay(10);                       // waits for the servo to reach the position
    }
    delay(500);
    for (pos = 105; pos >= 0; pos -= 1) { // goes from 120 degrees to 0 degrees to return to normal position
      myservo2.write(pos);              // tell servo to go to position in variable 'pos'
      delay(10);                       // waits for the servo to reach the position
    }
    delay(2000);
    for (pos = 90; pos >= 0; pos -= 1) { // goes from 90 degrees to 0 degrees to return to normal position
      myservo1.write(pos);              // tell servo to go to position in variable 'pos'
      delay(10);                       // waits for the servo to reach the position
    }
    function2();
}
void function4(){
  int pos;
    for (pos = 0; pos <= 65; pos += 1) { // goes from 0 degrees to 90 degrees to lift the lead
      // in steps of 1 degree
      myservo1.write(pos);              // tell servo to go to position in variable 'pos'
      delay(10);                       // waits for the servo to reach the position
    }
    delay(1000);
    for (pos = 65; pos <= 110; pos+=1){
      myservo1.write(pos);              // tell servo to go to position in variable 'pos'
      delay(10);                       // waits for the servo to reach the position
    }
    delay(5000);
    for (pos = 0; pos <= 120; pos += 1) { // goes from 0 degrees to 120 degrees to switch the button
      // in steps of 1 degree
      myservo2.write(pos);              // tell servo to go to position in variable 'pos'
      delay(2);
    }
    delay(200);
    for (pos = 120; pos >= 0; pos -= 1) { // goes from 120 degrees to 0 degrees to return to normal position
      myservo2.write(pos);              // tell servo to go to position in variable 'pos'
      delay(2);
    }
    delay(100);
    for (pos = 110; pos >= 0; pos -= 1) { // goes from 90 degrees to 0 degrees to return to normal position
      myservo1.write(pos);              // tell servo to go to position in variable 'pos'
      delay(5);                       // waits for the servo to reach the position
    }
    state = 0;
}
void loop()
{
  if(state == 1){
    switch (i){
      case 2:
        function2();
        break;
      case 3:
        function3();
        break;
      case 4:
        function4();
        break;
      default:
        function1();
    }
    i = rand() % 5;
  }
  delay(1000);
}
